<template>
  <v-container
    fluid
    tag="section"
  >
    <material-card
      icon="mdi-cart-plus"
      icon-small
      :title="$t('nuevoPedido')"
      color="secondary"
    >
      <v-row>
        <v-col cols="12" md="12" sm="12">
          <PedidosForm
            :pedido="pedidoData"
            @onPedidoGuardado="pedidoGuardado"
            @onCancelarGuardar="cancelarGuardado"
          />
          <v-card-text style="height: 0px; position: relative">
            <v-fab-transition>
              <v-btn
                v-if="pedidoId > 0"
                color="accent"
                dark
                absolute
                top
                right
                fab
                @click="abrirMateriales"
              >
                <v-icon>mdi-plus</v-icon>
              </v-btn>
            </v-fab-transition>
          </v-card-text>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" md="12" sm="12">
          <DetallePedidoTabla
            ref="detallePedidoTabla"
            :pedidoId="pedidoId"
            class="pl-4 pr-4"
          />
        </v-col>
      </v-row>
    </material-card>

    <v-navigation-drawer
      v-model="drawer"
      absolute
      temporary
      right
      width="60%"
      class="pt-4"
    >
      <MaterialesTabla
        v-if="pedidoId > 0"
        :esPedido="true"
        class="pt-2 pl-2"
        @onAgregarMaterial="guardarDetalle"
      />
      <v-divider></v-divider>

    </v-navigation-drawer>
  </v-container>
</template>

<script>
import PedidosForm from '@/components/Pedidos/PedidosForm'
import DetallePedidoTabla from '@/components/Pedidos/DetallePedidoTabla'
import MaterialesTabla from '@/components/Materiales/MaterialesTabla'
import DetallePedidoServicio from '@/store/services/DetallePedidoServicio'
export default {
  components: {
    PedidosForm,
    DetallePedidoTabla,
    MaterialesTabla
  },
  props: {

  },
  data () {
    return {
      modal: false,
      pedidoData: null,
      drawer: false,
      pedidoId: 0,
      form: {
        pedido_id: '',
        material_id: '',
        cantidad: ''
      }
    }
  },
  methods: {
    async guardarDetalle(value) {
      try {
        this.setFrom(value)
        // var response = ''
        let dataForm = new FormData()
        for (let key in this.form) {
          dataForm.append(key, this.form[key])
        }
        await DetallePedidoServicio.create(dataForm)
        this.$refs.detallePedidoTabla.refreshTable()
        this.disabled = true
      } catch (e) {console.log(e)
        if (e.response.status > 300) {
          console.log('error pedido')
        }
      }
    },
    setFrom(value) {
      this.form.pedido_id = this.pedidoId
      this.form.material_id = value.id
      this.form.cantidad = 0
    },
    nuevoPedido() {
      this.modal = true
    },
    pedidoGuardado(value) {
      this.pedidoId = value.id
    },
    editarPedido(value) {
      this.pedidoData = value
      this.modal = true
    },
    cancelarGuardado() {
      this.pedidoId = 0
      this.modal = false
    },
    agregarMaterial(value) {
      console.log(value)
    },
    abrirMateriales() {
      this.drawer = true
    }
  },
  created(){
  }
}
</script>

<style>

</style>
